#include "hmg.ch"
#include "hbcurl.ch"
#include "common.ch"
#include "fileio.ch"

#define HB_CURL_CURLSSH_AUTH_ANY              hb_bitNot( 0 )      /* all types supported by the server */
#define HB_CURL_CURLSSH_AUTH_NONE             0                   /* none allowed, silly but complete */
#define HB_CURL_CURLSSH_AUTH_PUBLICKEY        1                   /* public/private key files */
#define HB_CURL_CURLSSH_AUTH_PASSWORD         2                   /* password */
#define HB_CURL_CURLSSH_AUTH_HOST             4                   /* host key files */
#define HB_CURL_CURLSSH_AUTH_KEYBOARD         8                   /* keyboard interactive */
#define HB_CURL_CURLSSH_AUTH_DEFAULT          HB_CURL_CURLSSH_AUTH_ANY

Function Main()
Local aFont := ARRAY FONT "MS Shell Dlg" SIZE 9 		//"Segoe UI" SIZE 9 BOLD
Local i, aDrives:={}, nHandleCombo

SET FONT TO "MS Shell Dlg", 9

SET CENTURY ON
SET DATE TO ANSI

#pragma TEXTHIDDEN(1) 
/*
//Local SFTP server
cUrl:="sftp://localhost/"
UserLogin:="testSFTP"
UserPass:="SFTPtest"
nPort:=22
*/

//Public Online SFTP server
cUrl:="sftp://demo.wftpserver.com/"
UserLogin:="demo-user"
UserPass:="demo-user"
nPort:=2222

cPrivateKey:=""		//GetCurrentFolder()+"\PrvKey.ppk"
cPublicKey:=""			//GetCurrentFolder()+"\PubKey.pub"
cPKeyMD5:=""			//"cf:8d:17:f0:db:ef:84:7b:bb:62:c3:d4:3f:4a:93:13"

#pragma TEXTHIDDEN(0)

curlHandle := Nil
cRemoteDir:=""
cLocalDir:=GetCurrentFolder()+"\"

aRemoteDir:={}
aLocalDir:={}

FOR i = 65 TO 90
	IF IsDisk (CHR(i))
		AADD(aDrives, CHR(i) + ':')
	ENDIF
NEXT

cTitle := "Simple SFTP navigator"

DEFINE WINDOW sftp AT 0 , 0 WIDTH 805 HEIGHT 600 TITLE cTitle MAIN NOSIZE NOMAXIMIZE;
	ON RELEASE Disconnect() ;
	ON INTERACTIVECLOSE MsgYesNo ("Exit SFTP Navigator?", "Confirm", .T.)

	DEFINE MAIN MENU 
		DEFINE POPUP "File"
			MENUITEM "Connect to the server" ACTION Connect()
			MENUITEM "Disconnect from the server" ACTION Disconnect()
			SEPARATOR
			MENUITEM "Exit" ACTION ReleaseSFTP()
		END POPUP
		
		@ 525, 20  LABEL LabelF1 VALUE "F1 - Connect" ACTION { || IF (EMPTY(curlHandle), Connect(), Disconnect()) } AUTOSIZE
		@ 525, 145 LABEL LabelF2 VALUE "F2 - Drive" ACTION DriveList() AUTOSIZE
		@ 525, 240 LABEL LabelF5 VALUE "F5 - Copy (upload)" ACTION {|| IF (sftp.FocusedControl='LocalGrid', OnLocalKey( VK_F5 ), IF (sftp.FocusedControl='RemoteGrid', OnRemoteKey( VK_F5 ), Nil ) ) } AUTOSIZE
		@ 525, 380 LABEL LabelF6 VALUE "F6 - Rename" ACTION {|| IF (sftp.FocusedControl='LocalGrid', OnLocalKey( VK_F6 ), IF (sftp.FocusedControl='RemoteGrid', OnRemoteKey( VK_F6 ), Nil ) ) } AUTOSIZE
		@ 525, 490 LABEL LabelF7 VALUE "F7 - Make Folder" ACTION {|| IF (sftp.FocusedControl='LocalGrid', OnLocalKey( VK_F7 ), IF (sftp.FocusedControl='RemoteGrid', OnRemoteKey( VK_F7 ), Nil ) ) } AUTOSIZE
		@ 525, 610 LABEL LabelF8 VALUE "F8 - Delete" ACTION {|| IF (sftp.FocusedControl='LocalGrid', OnLocalKey( VK_F8 ), IF (sftp.FocusedControl='RemoteGrid', OnRemoteKey( VK_F8 ), Nil ) ) } AUTOSIZE
		@ 525, 700 LABEL LabelESC VALUE "Escape - Exit" ACTION ReleaseSFTP() AUTOSIZE
		
		ON KEY ESCAPE ACTION ReleaseSFTP()
		ON KEY F1 ACTION { || IF (EMPTY(curlHandle), Connect(), Disconnect()) }
		ON KEY F2 ACTION { || DriveList() }
		
		@ 0, 0 COMBOBOX ComboDrive ;
			ITEMS aDrives ;
			VALUE ASCAN( aDrives, GetDrvLetter() );	
			WIDTH 35 ;
			ON GOTFOCUS Nil ;
			ON CHANGE IF(aDrives[This.Value] # GetDrvLetter(), (cLocalDir := aDrives[This.Value] + "\", RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) ) ), Nil); 
			ON LOSTFOCUS Nil ;
			ON ENTER Nil ;
			ON DISPLAYCHANGE Nil ;
			ON DROPDOWN Nil ;
			ON CLOSEUP Nil;
			NOTABSTOP 
		
		@ 3,40 LABEL LabelLocal VALUE cLocalDir WIDTH 360 HEIGHT 18 ENDELLIPSES
		@ 22,0 GRID LocalGrid ;
			WIDTH 399 ;
			HEIGHT 490 ;
			HEADERS {'File Name','Size','Date', 'Time', 'Attr'} ;
			WIDTHS {140,65,75,60,23};
			ITEMS aLocalDir ;
			VALUE 1 ;
			JUSTIFY {GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_RIGHT, GRID_JTFY_RIGHT, GRID_JTFY_LEFT } ;
			ON GOTFOCUS ( sftp.LabelF5.Value:="F5 - Copy (upload)" ) ;
			ON DBLCLICK OnLocalKey( VK_RETURN ) ;
			ON KEY OnLocalKey()
			
		sftp.LocalGrid.PaintDoubleBuffer := .T.
		sftp.LocalGrid.Image (.T.) := {"file", "folder"}
		
		FOR i = 1 TO sftp.LocalGrid.ColumnCOUNT  
			sftp.LocalGrid.ColumnDYNAMICFONT (i) := {|| IF ( 'D' $ Upper ( sftp.LocalGrid.CellEx( This.CellRowIndex, 5) ), aFont, NIL) }	//folders are bolded
			sftp.LocalGrid.HeaderDYNAMICFORECOLOR (i) := {|| RED  }	//Headers fonts in red
			sftp.LocalGrid.HeaderDYNAMICBACKCOLOR (i) := {|| BLACK }	//Headers background in black - why don't work ????
		NEXT i
			
		RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) )

		@ 3,400 LABEL LabelRemote VALUE cRemoteDir WIDTH 400 HEIGHT 18 ENDELLIPSES 
		@ 22,400 GRID RemoteGrid ;
			WIDTH 399 ;
			HEIGHT 490 ;
			HEADERS {'File Name','Size','Date', 'Time', 'Attr'} ;
			WIDTHS {130,65,75,45,63};
			ITEMS aRemoteDir;
			JUSTIFY {GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_RIGHT, GRID_JTFY_RIGHT, GRID_JTFY_LEFT } ;
			ON GOTFOCUS ( sftp.LabelF5.Value:="F5 - Copy (download)" ) ;
			ON DBLCLICK OnRemoteKey( VK_RETURN ) ;
			ON KEY OnRemoteKey()
	
		sftp.RemoteGrid.PaintDoubleBuffer := .T.
		sftp.RemoteGrid.Image (.T.) := {"file", "folder"}
		
		FOR i = 1 TO sftp.RemoteGrid.ColumnCOUNT  
			sftp.RemoteGrid.ColumnDYNAMICFONT (i) := {|| IF ( 'D' $ Upper ( sftp.RemoteGrid.CellEx(This.CellRowIndex, 5) ), aFont, NIL) }	//folders are bolded
			sftp.RemoteGrid.HeaderDYNAMICFORECOLOR (i) := {|| RED  }	//Headers fonts in red
			sftp.RemoteGrid.HeaderDYNAMICBACKCOLOR (i) := {|| BLACK }	//Headers background in black - why don't work ????
		NEXT i
		
		sftp.LocalGrid.SetFocus

	END MENU
END WINDOW

CENTER WINDOW sftp
ACTIVATE WINDOW sftp

Return Nil

***********************************
FUNCTION RefreshRemoteGrid ( aRemoteDir )
Local aItem, i
sftp.RemoteGrid.DeleteAllItems

FOR EACH aItem IN aRemoteDir
	sftp.RemoteGrid.AddItem(aItem)
	i := sftp.RemoteGrid.ItemCount
	IF 'D' $ Upper ( sftp.RemoteGrid.CellEx( i, 5) )
		sftp.RemoteGrid.ImageIndex (i, 1) := 1		//folders icon
	ENDIF
NEXT 
sftp.RemoteGrid.Value := 1
sftp.LabelRemote.Value := "/" + cRemoteDir
RETURN Nil
***********************************
FUNCTION RefreshLocalGrid ( aLocalDir )
Local aItem, i
sftp.LocalGrid.DeleteAllItems

FOR EACH aItem IN aLocalDir
	sftp.LocalGrid.AddItem(aItem)
	i := sftp.LocalGrid.ItemCount
	IF 'D' $ Upper ( sftp.LocalGrid.CellEx( i, 5) )
		sftp.LocalGrid.ImageIndex (i, 1) := 1		//folders icon
	ENDIF
NEXT 
sftp.LocalGrid.Value := 1
sftp.LabelLocal.Value := cLocalDir
RETURN Nil

***********************************
FUNCTION Connect()
Local cErr, curlErr

cRemoteDir := ""
aRemoteDir := {}

IF !EMPTY( curlHandle )
	Disconnect()
ENDIF	

IF !ConfirmToConnect()
	RETURN Nil	
ENDIF
	
info_('Init cURL')

//Init
curlHandle := curl_easy_init()
IF EMPTY(curlHandle)
	Info_("Error while init cURL lib.",.T.)
	Disconnect()
ELSE
	cURL += IF (Right (cURL, 1) # '/', '/', '' )		//add slash to cURL
	info_('Connecting to ' + cURL)
	curl_easy_reset( curlHandle )
	Login_SFTP( cURL )	
	curlErr := curl_easy_perform(curlHandle)
	IF curlErr # 0
		MsgStop ( curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')' , 'Error')
		Disconnect()
	ELSE
		cErr:=Dir_SFTP( cRemoteDir , @aRemoteDir)
		IF !EMPTY ( cErr )
			MsgStop( cErr, 'Error')
		ELSE
			RefreshRemoteGrid ( aRemoteDir )
			sftp.title:=cTitle + " " + cUrl + cRemoteDir
			sftp.LabelF1.Value:= "F1 - Disconnect"
		ENDIF
	ENDIF
ENDIF

WAIT CLEAR

RETURN Nil 
***********************************
FUNCTION Disconnect()
cRemoteDir := ""
IF !EMPTY(curlHandle)
	curl_global_cleanup( curlHandle )
ENDIF

curlHandle:=Nil
sftp.title:=cTitle
sftp.RemoteGrid.DeleteAllItems
sftp.LabelRemote.Value := ""
sftp.LabelF1.Value:= "F1 - Connect"

RETURN 
****************************************************************************************
Function Dir_SFTP( cFolder, aDirectory )
Local cRet:="", cSftpURL, nFSize, cDirList, errbuf:='', cList:="", aDirList

Default cFolder:=""
Default aDirectory:={}

IF EMPTY( curlHandle )
	Return "First connect to the server."
ENDIF

info_('Directory listing ...')

cSftpURL:=cUrl + curl_easy_escape( curlHandle, cFolder )
curl_easy_reset( curlHandle )

Login_SFTP( cSftpURL )

//curl_easy_setopt(curlHandle, HB_CURLOPT_DIRLISTONLY )		//list file name only
curl_easy_setopt(curlHandle, HB_CURLOPT_DL_BUFF_SETUP, .T. )
curl_easy_setopt(curlHandle, HB_CURLOPT_PROGRESSBLOCK, {| nPos, nLen | info_('Directory listing ... ' + Str( ( nPos / nLen ) * 100, 6, 2 ) + '%') } )
curl_easy_setopt(curlHandle, HB_CURLOPT_NOPROGRESS, .F. )

/* Do everything */
curlErr := curl_easy_perform(curlHandle)

curl_easy_setopt( curlHandle, HB_CURLOPT_DL_BUFF_GET, @cDirList )
aDirList:=HB_ATOKENS(cDirList, CHR(10) )
ASIZE(aDirList, LEN (aDirList) - 1)

//get name, size, date, time, atrrib
FOR EACH cList IN aDirList
	a1List := HB_ATOKENS( cList )
	a1Dir := ARRAY(5)
	a1Dir [5] := a1List [1]						//attributes
	a1Dir [2] := a1List [5]						//size
	IF AT( ":", a1List [8]) > 0 					//time insteed year
		a1Dir [3] := a1List [6] + " " + a1List [7]	//date (w/o year)
		a1Dir [4] := a1List [8]					//time
	ELSE
		a1Dir [3] := a1List [6] + " " + a1List [7] + " " + a1List [8]	//date with year 
		a1Dir [4] := ""						//no time
	ENDIF
	cfName:=LTRIM( cList )
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [1]) + 1 ))
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [2]) + 1 ))
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [3]) + 1 ))
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [4]) + 1 ))
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [5]) + 1 ))
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [6]) + 1 ))
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [7]) + 1 ))
	cfName:=LTRIM(SUBSTR( cfName, LEN( a1List [8]) + 1 ))
	
	IF 'D' $ Upper(a1List[1])
		a1Dir[1] := "[ " + cfName + " ]"			//dir name
		a1Dir[2] := "<DIR>"
	ELSE
		a1Dir[1] := cfName 						// file name
	ENDIF
	
	IF 'D' $ Upper(a1List[1]) .AND. cFName=="."		// Skip "." folder
		LOOP
	ENDIF
	AADD(aDirectory, a1Dir)
	
	IF !EMPTY(cFolder)										//no root
		IF ASCAN( aDirectory, { |x| x[1] == "[ .. ]" }) = 0		//no parrent directory
			AADD(aDirectory, {"[ .. ]", "<DIR>", "", "", "d" })	//add parent directory
		ENDIF
	ENDIF
	
	aDirectory:=ASORT ( aDirectory, , , { |x, y| IF('D' $ Upper(x[5]), '0', '1') + Lower(x[1]) < IF('D' $ Upper(y[5]), '0', '1') + Lower(y[1])  } )
	
NEXT 

/* Report any errors */
IF curlErr # 0
	cRet:=curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')'
ENDIF

WAIT CLEAR

RETURN cRet
*******************************************************************************
FUNCTION LocalDir (aDir)
Local a1List, aDirectory:={}, a1Dir
FOR EACH a1List IN aDir
	IF 'D' $ Upper(a1List[5]) .AND. a1List[1] =="."		// Skip "." folder
		LOOP
	ENDIF
	a1Dir := ARRAY(5)
	IF 'D' $ Upper (a1List[5])						//dir name
		a1Dir[1] := "[ " + a1List[1] + " ]"
		a1Dir[2] := "<DIR>"
	ELSE											//file name
		a1Dir[1] := a1List[1]
		a1Dir[2] := Alltrim(Str(a1List[2]))
	ENDIF
	a1Dir[3] := a1List[3]
	a1Dir[4] := a1List[4]
	a1Dir[5] := a1List[5] 
	AADD(aDirectory, a1Dir)
NEXT 

//soft list
aDirectory:=ASORT ( aDirectory, , , { |x, y| IF('D' $ Upper(x[5]), '0', '1') + Lower(x[1]) < IF('D' $ Upper(y[5]), '0', '1') + Lower(y[1])  } ) 

RETURN aDirectory
***********************************
Function Send_SFTP( cFile, cSFile )
Local cRet:="", cSftpURL, nFSize, cRemoteFile

Default cSFile := cFile


IF EMPTY( curlHandle )
	Return "First connect to the server."
ENDIF

IF EMPTY( cFile ) .OR. !FILE (cFile)
	RETURN "No File " + cFile
ENDIF

cRemoteFile:=HB_FNameNameExt(cSFile)
cSftpURL:=cUrl + cRemoteDir + cRemoteFile
nFSize:=hb_FSize(cFile)

info_('Uploading ...')

curl_easy_reset( curlHandle )

Login_SFTP( cSftpURL )

//curl_easy_setopt(curlHandle, HB_CURLOPT_URL, cSftpURL)
curl_easy_setopt(curlHandle, HB_CURLOPT_UPLOAD, 1)
curl_easy_setopt(curlHandle, HB_CURLOPT_UL_FILE_SETUP, cFile)
curl_easy_setopt(curlHandle, HB_CURLOPT_INFILESIZE_LARGE, nFSize)
curl_easy_setopt(curlHandle, HB_CURLOPT_PROGRESSBLOCK, {| nPos, nLen | info_('Uploading ... ' + Str( ( nPos / nLen ) * 100, 6, 2 ) + '%' ) } )
curl_easy_setopt(curlHandle, HB_CURLOPT_NOPROGRESS, 0 )

/* Do everything */
curlErr := curl_easy_perform(curlHandle)

/* Report any errors */
IF curlErr # 0
	cRet:=curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')'
ENDIF

WAIT CLEAR

RETURN cRet
****************************************************************************************
Function Recv_SFTP(cRemoteFile, cLocalFile)
Local cRet:="", cSftpURL, nFSize 

DEFAULT cLocalFile:=cRemoteFile

IF EMPTY( curlHandle )
	Return "First connect to the server."
ENDIF

cSftpURL:=cUrl + cRemoteDir + cRemoteFile

info_('Downloading ...')

curl_easy_reset( curlHandle )

Login_SFTP( cSftpURL )

//curl_easy_setopt(curlHandle, HB_CURLOPT_URL, cSftpURL)
curl_easy_setopt(curlHandle, HB_CURLOPT_DOWNLOAD ) 
curl_easy_setopt(curlHandle, HB_CURLOPT_DL_FILE_SETUP, cLocalFile )
curl_easy_setopt(curlHandle, HB_CURLOPT_PROGRESSBLOCK, {| nPos, nLen | info_('Downloading ... ' + Str( ( nPos / nLen ) * 100, 6, 2 ) + '%' ) } )
curl_easy_setopt(curlHandle, HB_CURLOPT_NOPROGRESS, 0 )

/* Do everything */
curlErr := curl_easy_perform(curlHandle)

curl_easy_reset( curlHandle )

/* Report any errors */
IF curlErr # 0
	cRet:=curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')'
ENDIF

WAIT CLEAR

RETURN cRet
*****************************************************************************************
Function Delete_SFTP( cRemoteFile )
Local cRet:="", cSftpURL, cDelCmd:="rm"

DEFAULT cRemoteFile := ""

IF EMPTY(cRemoteFile)
	RETURN "No file selected"
ENDIF

IF EMPTY( curlHandle )
	Return "First connect to the server."
ENDIF

info_('Deleting file ...')

//cSftpURL:= cUrl + STRTRAN( curl_easy_escape( curlHandle, cRemoteDir + cRemoteFile ), "%2F", "/")
cSftpURL:= cUrl + curl_easy_escape( curlHandle, cRemoteDir + cRemoteFile )
aQuote :=  {cDelCmd + ' "' + cRemoteDir + cRemoteFile +'"' }

curl_easy_reset( curlHandle )

Login_SFTP( cSftpURL )

curl_easy_setopt(curlHandle, HB_CURLOPT_UPLOAD)
curl_easy_setopt(curlHandle, HB_CURLOPT_UL_NULL_SETUP )
curl_easy_setopt(curlHandle, HB_CURLOPT_NOPROGRESS, .T. )
curl_easy_setopt(curlHandle, HB_CURLOPT_POSTQUOTE,  aQuote )

/* Do everything */
curlErr := curl_easy_perform(curlHandle)

/* Report any errors */
IF curlErr # 0
	cRet:=curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')'
ENDIF

WAIT CLEAR

RETURN cRet
*****************************************************************************************
Function DeleteFolder_SFTP( cRemoteFolder )
Local cRet:="", cSftpURL, cDelCmd:="rmdir"
DEFAULT cRemoteFolder := ""

IF EMPTY(cRemoteFolder)
	RETURN "No folder selected"
ENDIF

IF EMPTY( curlHandle )
	Return "First connect to the server."
ENDIF

info_('Deleting folder ...')

cSftpURL:= cUrl + curl_easy_escape( curlHandle, cRemoteDir )
aQuote :=  {cDelCmd + ' "' + cRemoteDir + cRemoteFolder + '"' }

curl_easy_reset( curlHandle )

Login_SFTP( cSftpURL )

curl_easy_setopt(curlHandle, HB_CURLOPT_NOPROGRESS, .T. )
curl_easy_setopt(curlHandle, HB_CURLOPT_POSTQUOTE,  aQuote )

/* Do everything */
curlErr := curl_easy_perform(curlHandle)

/* Report any errors */
IF curlErr # 0
	cRet:=curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')'
ENDIF

WAIT CLEAR

RETURN cRet
*****************************************************************************************
Function MakeFolder_SFTP( cRemoteFolder )
Local cRet:="", cSftpURL, cMakeCmd:="mkdir"
DEFAULT cRemoteFolder := ""

IF EMPTY(cRemoteFolder)
	RETURN "No folder selected"
ENDIF

IF EMPTY( curlHandle )
	Return "First connect to the server."
ENDIF

info_('Making folder ...')

cSftpURL:= cUrl + curl_easy_escape( curlHandle, cRemoteDir )
aQuote :=  {cMakeCmd + ' "' + cRemoteDir + cRemoteFolder +  '"' }

curl_easy_reset( curlHandle )

Login_SFTP( cSftpURL )

curl_easy_setopt(curlHandle, HB_CURLOPT_NOPROGRESS, .T. )
curl_easy_setopt(curlHandle, HB_CURLOPT_POSTQUOTE,  aQuote )

/* Do everything */
curlErr := curl_easy_perform(curlHandle)

/* Report any errors */
IF curlErr # 0
	cRet:=curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')'
ENDIF

WAIT CLEAR

RETURN cRet

*****************************************************************
Function Rename_SFTP(cRemoteFileOld, cRemoteFileNew)
Local cRet:="", cSftpURL, cRenameCmd:="rename"
DEFAULT cRemoteFileOld := "", cRemoteFileNew := "" 

IF EMPTY( curlHandle )
	Return "First connect to the server."
ENDIF

IF EMPTY(cRemoteFileOld)
	RETURN "No file selected."
ENDIF

IF EMPTY(cRemoteFileNew)
	RETURN "A new file name has not been set."
ENDIF

info_('Renaming ...')

cSftpURL:= cUrl + curl_easy_escape( curlHandle, cRemoteDir )
aQuote :=  {cRenameCmd + ' "' + cRemoteDir + cRemoteFileOld + '" "' + cRemoteDir + cRemoteFileNew +'"'  }

curl_easy_reset( curlHandle )

Login_SFTP( cSftpURL )

curl_easy_setopt(curlHandle, HB_CURLOPT_NOPROGRESS, .T. )
curl_easy_setopt(curlHandle, HB_CURLOPT_POSTQUOTE,  aQuote )

/* Do everything */
curlErr := curl_easy_perform(curlHandle)

/* Report any errors */
IF curlErr # 0
	cRet:=curl_easy_strerror(curlErr) + ' (' + Alltrim( Str(curlErr) ) + ')'
ENDIF

curl_easy_reset( curlHandle )

WAIT CLEAR

RETURN cRet
******************************************************************************************
FUNCTION Login_SFTP( cSftpURL )
Local AUTH:=HB_CURL_CURLSSH_AUTH_NONE

curl_easy_setopt(curlHandle, HB_CURLOPT_URL, cSftpURL)
IF !EMPTY(UserLogin)
	curl_easy_setopt(curlHandle, HB_CURLOPT_USERNAME, UserLogin)
ENDIF
IF !EMPTY(UserPass)
	curl_easy_setopt(curlHandle, HB_CURLOPT_PASSWORD, UserPass)
	AUTH += HB_CURL_CURLSSH_AUTH_PASSWORD
ENDIF

curl_easy_setopt(curlHandle, HB_CURLOPT_PORT, nPort)
curl_easy_setopt(curlHandle, HB_CURLOPT_PROTOCOLS, HB_CURLPROTO_SFTP)

IF (!EMPTY(cPrivateKey) .AND. FILE (cPrivateKey)) .OR. (!EMPTY(cPublicKey) .AND. FILE (cPublicKey))
	AUTH += HB_CURL_CURLSSH_AUTH_PUBLICKEY
	
	IF !EMPTY(cPrivateKey)
		curl_easy_setopt(curlHandle, HB_CURLOPT_SSH_PRIVATE_KEYFILE, cPrivateKey )
	ENDIF
	IF !EMPTY(cPublicKey)
		curl_easy_setopt(curlHandle, HB_CURLOPT_SSH_PUBLIC_KEYFILE, cPublicKey )
	ENDIF
	
	curl_easy_setopt(curlHandle, HB_CURLOPT_KEYPASSWD, "")
ENDIF

curl_easy_setopt(curlHandle, HB_CURLOPT_SSH_AUTH_TYPES, AUTH)

IF !EMPTY (cPKeyMD5)
	curl_easy_setopt(curlHandle, HB_CURLOPT_SSH_HOST_PUBLIC_KEY_MD5, cPKeyMD5 )
ENDIF

curl_easy_setopt( curlHandle, HB_CURLOPT_VERBOSE, .T. )

RETURN

******************************************************************************************
Function info_(cMess, lWait)
Local nTimeIni := hb_MilliSeconds()
Default lWait:=.F.
DO EVENTS
Wait Window cMess NoWait
IF lWait
	WHILE( ( hb_MilliSeconds() - nTimeIni ) < 3 * 1000 )
		DO EVENTS
		hb_releaseCPU()
	ENDDO
ENDIF
RETURN Nil
********************************
FUNCTION RemoteListFiles()
Local cErr
aRemoteDir:={}
cErr:=Dir_SFTP( cRemoteDir , @aRemoteDir)
IF !EMPTY ( cErr )
	MsgStop( cErr )
ELSE
	RefreshRemoteGrid ( aRemoteDir )
ENDIF
RETURN 
********************************
FUNCTION OnRemoteKey( vKey )
Local cFName := sftp.RemoteGrid.CellEx( sftp.RemoteGrid.CellRowFocused, 1)
Local xErr, hWnd, cFNew
Local lIsDir := 'D' $ Upper ( sftp.RemoteGrid.CellEx( sftp.RemoteGrid.CellRowFocused, 5) )
Default vKey:=HMG_GetLastVirtualKeyUp(@hWnd)

HMG_CleanLastVirtualKeyUp()
HMG_CleanLastVirtualKeyDown()
HMG_KeyboardClearBuffer()

IF vKey == VK_RETURN .AND. !HB_isNil( hWnd )		//prevents the event from being re-triggered
	RETURN Nil
ENDIF

IF lIsDir		//extract real folder name
	cFName := SUBSTR( cFName, 3, LEN( cFName ) - 4 )
ENDIF

DO CASE
	CASE  vKey == VK_RETURN		//change folder
		IF lIsDir
			cRemoteDir := STRTRAN( SUBSTR( TrueName( "/" + cRemoteDir + cFName + "/" ), Len ( TrueName("/") ) + 1 ), "\", "/")	
			RemoteListFiles()
		ENDIF

	CASE vKey == VK_F5			//receive file
		IF !lIsDir	//files only
			cFNew:=MyInputBox ( "Copy (downpload) as:", "Copy (download)" , cFName )
			IF !EMPTY(cFNew)
				xErr := Recv_SFTP ( cFName, cLocalDir + cFNew )
				IF !EMPTY ( xErr )
					MsgStop( xErr, 'Error')
				ELSE
					RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) )
				ENDIF
			ENDIF
		ENDIF
		
	CASE	vKey == VK_F6 			//rename
		cFNew:=MyInputBox ( "Enter new name", "Rename" , cFName )
		IF !EMPTY(cFNew) .AND. !(cfNew == cfName)
			xErr := Rename_SFTP(cFName, cFNew)
			IF !EMPTY ( xErr )
				MsgStop( xErr, 'Error')
			ELSE
				RemoteListFiles()
			ENDIF
		ENDIF

	CASE vKey == VK_F7			//make remote folder
		cFNew:=MyInputBox ( "Name new folder", "New remote folder" , "" )
		IF !EMPTY(cFNew)
			xErr := MakeFolder_SFTP ( cFNew )
			IF !EMPTY ( xErr )
				MsgStop( xErr, 'Error')
			ELSE
				RemoteListFiles()
			ENDIF
		ENDIF

	CASE vKey == VK_F8 .AND. MsgYesNo('Are you sure you want to delete "' + cFName + '" ?', "Confirm", .T.)			//delete
		IF !lIsDir	//file
			xErr := Delete_SFTP( cFName )	
			IF !EMPTY ( xErr )
				MsgStop( xErr, 'Error')
			ELSE
				RemoteListFiles()
			ENDIF
		ELSE			//remove remote folder
			xErr := DeleteFolder_SFTP( cFName )	
			IF !EMPTY ( xErr )
				MsgStop( xErr, 'Error')
			ELSE
				RemoteListFiles()
			ENDIF
		ENDIF
ENDCASE

HMG_CleanLastVirtualKeyUp()
HMG_CleanLastVirtualKeyDown()
HMG_KeyboardClearBuffer()

RETURN Nil
*********************************
FUNCTION OnLocalKey( vKey )
Local cFName := sftp.LocalGrid.CellEx( sftp.LocalGrid.CellRowFocused, 1)
Local lIsDir := 'D' $ Upper ( sftp.LocalGrid.CellEx( sftp.LocalGrid.CellRowFocused, 5) )
Local xErr, hWnd,cFNew
Default vKey:=HMG_GetLastVirtualKeyUp(@hWnd)

HMG_CleanLastVirtualKeyUp()
HMG_CleanLastVirtualKeyDown()
HMG_KeyboardClearBuffer()

IF vKey == VK_RETURN .AND. !HB_isNil( hWnd )		//prevents the event from being re-triggered
	RETURN Nil
ENDIF

IF lIsDir		//extract real folder name
	cFName := SUBSTR( cFName, 3, LEN( cFName ) - 4 )
ENDIF

DO CASE
	CASE vKey == VK_RETURN		//change folder
		IF lIsDir
			cLocalDir := HB_PathNormalize( cLocalDir + cFName + "\" )		//folder name
			RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) )
		ENDIF

	CASE	vKey == VK_F5			//send file
		IF !lIsDir	//files only
			cFNew:=MyInputBox ( "Copy (upload) as:", "Copy (upload)" , cFName )
			IF !EMPTY(cFNew)
				xErr := Send_SFTP ( cLocalDir + cFName, cFNew )
				IF !EMPTY ( xErr )
					MsgStop( xErr, 'Error')
				ELSE
					RemoteListFiles()
				ENDIF
			ENDIF
		ENDIF
		
	CASE	vKey == VK_F6 			//rename
		cFNew:=MyInputBox ( "Enter new name", "Rename" , cFName )
		IF !EMPTY(cFNew) .AND. !(cfNew == cfName)
			xErr := hb_vfRename( cLocalDir + cFname , cLocalDir + cFNew )
			IF xErr # 0
				MsgStop( "DOS error "+HB_ValToStr(xErr), 'Error')
			ELSE
				RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) )
			ENDIF
		ENDIF
		
	CASE	vKey == VK_F7 			//Make directory
		cFNew:=MyInputBox ( "Name new folder", "New folder" , "" )
		IF !EMPTY(cFNew) 
			xErr := hb_DirCreate( cLocalDir + cFNew )
			IF xErr # 0
				MsgStop( "DOS error "+HB_ValToStr(xErr), 'Error')
			ELSE
				RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) )
			ENDIF
		ENDIF

		
	CASE	vKey == VK_F8 .AND. MsgYesNo('Are you sure you want to delete "' + cFName + '" ?', "Confirm", .T.)			//delete
		IF lIsDir //folder
			xErr := HB_DirDelete( cLocalDir + cFName )
			IF xErr # 0
				MsgStop( "DOS error "+HB_ValToStr(xErr), 'Error')
			ELSE
				RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) )
			ENDIF
		ELSE
			IF !HB_FileDelete( cLocalDir + cFName )
				MsgStop( "DOS error "+HB_ValToStr(FERROR()), 'Error')
			ELSE
				RefreshLocalGrid ( LocalDir(DIRECTORY(cLocalDir, "HSD")) )
			ENDIF

		ENDIF

ENDCASE

HMG_CleanLastVirtualKeyUp()
HMG_CleanLastVirtualKeyDown()
HMG_KeyboardClearBuffer()

RETURN Nil
********************************************
FUNCTION ReleaseSFTP()
IF sftp.FocusedControl == 'ComboDrive'
	ComboBoxDropdownClose(GetControlHandle ('ComboDrive', 'sftp'))
	_PushKey ( VK_TAB )
	RETURN Nil
ENDIF
IF MsgYesNo ("Exit SFTP Navigator?", "Confirm", .T.)
	ThisWindow.Release
ENDIF
RETURN Nil
*******************************************
FUNCTION GetDrvLetter()
//Local cDriveLetter
//hb_FNameSplit( cLocalDir, , , , @cDriveLetter )
//RETURN Upper (cDriveLetter) + ":"
RETURN Upper ( Left ( cLocalDir, 2) )
*******************************************
FUNCTION DriveList()
ComboBoxDropdown( GetControlHandle ('ComboDrive', 'sftp') )
sftp.ComboDrive.SetFocus
RETURN Nil
*******************************************
FUNCTION ComboBoxDropdown( nHandle )
Default nHandle := GetControlHandle (this.name, thiswindow.name)
ComboBoxShowDropDown(nHandle)
RETURN Nil
*******************************************
FUNCTION ComboBoxDropdownClose( nHandle )
Default nHandle := GetControlHandle (this.name, thiswindow.name)
ComboBoxShowDropDownClose( nHandle )
RETURN Nil
*******************************************
#pragma BEGINDUMP

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"
#include <wingdi.h>

HB_FUNC ( COMBOBOXSHOWDROPDOWN )

{
    HWND hWnd1;
    hWnd1 = (HWND) hb_parnl (1);
    SendMessage((HWND) hWnd1,CB_SHOWDROPDOWN,    (WPARAM)(int) 1,(LPARAM)(int) 0);
}

HB_FUNC ( COMBOBOXSHOWDROPDOWNCLOSE )

{
    HWND hWnd1;
    hWnd1 = (HWND) hb_parnl (1);
    SendMessage((HWND) hWnd1,CB_SHOWDROPDOWN,    (WPARAM)(int) 0,(LPARAM)(int) 0);
}

#pragma ENDDUMP   


********************************************
FUNCTION ConfirmToConnect()
Local lConnect := .F., cFile

DEFINE WINDOW ConnectParams AT 197 , 394 WIDTH 445 HEIGHT 335 TITLE "Settings for connection to the server" MODAL

	ON KEY ESCAPE ACTION ThisWindow.Release

	@20,20 LABEL LabelURL VALUE "Host URL:" AUTOSIZE
	@50,20 LABEL LabelPort VALUE "Port:" AUTOSIZE
	@80,20 LABEL LabelUser VALUE "User name:" AUTOSIZE
	@110,20 LABEL LabelPass VALUE "Password:" AUTOSIZE
	@140,20 LABEL LabelMD5 VALUE "Host Public Key MD5:" AUTOSIZE
	@170,20 LABEL LabelPubK VALUE "Host Public Key file:" AUTOSIZE
	@200,20 LABEL LabelPrvK VALUE "Host Private Key file:" AUTOSIZE

	@20, 130 TEXTBOX TextUrl WIDTH 230 VALUE cUrl
	@50, 130 TEXTBOX TextPort WIDTH 50 VALUE nPort NUMERIC
	@80, 130 TEXTBOX TextUser WIDTH 230 VALUE UserLogin
	@110,130 TEXTBOX TextPass WIDTH 230 VALUE UserPass PASSWORD
	@140,130 TEXTBOX TextMD5 WIDTH 230 VALUE cPKeyMD5
	@170,130 TEXTBOX TextPubK WIDTH 230 VALUE cPublicKey
	@200,130 TEXTBOX TextPrvK WIDTH 230 VALUE cPrivateKey

	@170,370 BUTTON ButtonPubK CAPTION "..." ;
		ACTION (cFile := Getfile ( { {'All Files','*.*'} } , 'Select Public Key File' , GetCurrentFolder()+"\" , .F. , .T. ),;
		IF(!EMPTY(cFile), ConnectParams.TextPubK.Value := cFile, Nil));
		WIDTH 30 HEIGHT 20
	@200,370 BUTTON ButtonPrvK CAPTION "..." ;
		ACTION (cFile := Getfile ( { {'All Files','*.*'} } , 'Select Private Key File' , GetCurrentFolder()+"\" , .F. , .T. ),;
		IF(!EMPTY(cFile), ConnectParams.TextPrvK.Value := cFile, Nil));
		WIDTH 30 HEIGHT 20
	
	@250,90 BUTTON ButtonOk CAPTION "Connect" ;
		ACTION ( lConnect := .T.,;
		cUrl := ConnectParams.TextUrl.Value, ;
		nPort := ConnectParams.TextPort.Value, ;
		UserLogin := ConnectParams.TextUser.Value, ;
		UserPass := ConnectParams.TextPass.Value, ;
		cPKeyMD5 := ConnectParams.TextMD5.Value, ;
		cPublicKey := ConnectParams.TextPubK.Value, ;
		cPrivateKey := ConnectParams.TextPrvK.Value, ;
		ThisWindow.Release) ;
		WIDTH 100
	@250,250 BUTTON ButtonCancel CAPTION "Cancel" ACTION ThisWindow.Release WIDTH 100
	
	ConnectParams.ButtonOk.SetFocus
	
END WINDOW

CENTER WINDOW ConnectParams
ACTIVATE WINDOW ConnectParams

RETURN lConnect
**************************************
FUNCTION MyInputBox( cMess, cTitle, cValue )
Local cRet:=""
Default cMess:="", cTitle:=""

IF hb_isNIL( cValue )
	RETURN cRet
ENDIF

DEFINE WINDOW MyInpBox AT 0 , 0 WIDTH 400 HEIGHT 110 TITLE cTitle MODAL NOSIZE

	ON KEY ESCAPE ACTION ReleaseMyInpBox()

	@5,20 LABEL Label1 VALUE cMess AUTOSIZE
	@25,20 TEXTBOX Text1 WIDTH 350 HEIGHT 18 VALUE cValue ON ENTER ( cRet:=MyInpBox.Text1.Value, ReleaseMyInpBox()) 
	
	@50,190 BUTTON ButtonOk CAPTION "&OK" ;
		ACTION ( cRet:=MyInpBox.Text1.Value, ReleaseMyInpBox()) ;
		WIDTH 80 HEIGHT 24
	@50,290 BUTTON ButtonCancel CAPTION "&Cancel" ACTION ReleaseMyInpBox() WIDTH 80 HEIGHT 24
	
	MyInpBox.Text1.SetFocus
	
END WINDOW

CENTER WINDOW MyInpBox
ACTIVATE WINDOW MyInpBox

RETURN cRet
*******************************************
FUNCTION	ReleaseMyInpBox()
//It's to prevent possible occurrence issue of event synchronization (window release) during the quick call of the InputBox.
//http://hmgforum.com/viewtopic.php?p=51617#p51617
DO WHILE IsWindowActive(MyInpBox)
	MyInpBox.Release
ENDDO	
RETURN Nil